﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static void Main(string[] args)
        {
            Task<int> task = new Task<int>(() =>
            {
                WriteLog("TEST0");
                Thread.Sleep(5000);
                return 1;
            });

            task.Start();

            WriteLog("This");

            Task<int> task2 = new Task<int>(() =>
            {
                WriteLog("TEST1");
                Thread.Sleep(5000);
                return 1;
            });
            task2.Start();

            task.ContinueWith((arg) =>
            {
                WriteLog("TEST2");
            }, TaskContinuationOptions.ExecuteSynchronously);

            Console.WriteLine(task.IsCompleted);
            Thread.Sleep(6000);
            Console.WriteLine(task.IsCompleted);

            task.ContinueWith((arg) =>
            {
                WriteLog("TEST3");
            }, TaskContinuationOptions.ExecuteSynchronously);

            Console.ReadLine();
        }

        private static void WriteLog(string v)
        {
            Console.WriteLine($"[{Thread.CurrentThread.ManagedThreadId}] " + v);
        }
    }

}
